/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package exemplo.java;

import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 *
 * @author Mateus
 */
public class Serial {


    SerialPort serialPort;
    InputStream sin;
    OutputStream sout;

    void connect(String portName) throws Exception {
        CommPortIdentifier portIdentifier = CommPortIdentifier.getPortIdentifier(portName);
        if (portIdentifier.isCurrentlyOwned()) {
            System.out.println("Error: Port is currently in use");
        } else {
            CommPort commPort = portIdentifier.open(this.getClass().getName(), 2000);
            if (commPort instanceof SerialPort) {
                serialPort = (SerialPort) commPort;
                serialPort.setSerialPortParams(115200, SerialPort.DATABITS_8, SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
                sin = serialPort.getInputStream();
                sout = serialPort.getOutputStream();
            } else {
                System.out.println("Error: Only serial ports are handled by this example.");
            }
        }
    }
    
    void write(byte[] b) throws IOException {
        sout.write(b);
    }
    
    void write(String s) throws IOException {
        System.out.print("Sending: "+s);
        sout.write(s.getBytes());
    }
    
    void close() {
        serialPort.close();
    }
    
    void cleanRecv() throws IOException {
        sin.skip(sin.available());
    }
    byte readByte() throws IOException, InterruptedException {
        byte b = (byte) sin.read();
        for (int i = 0; i < 5 && b == -1; ++i)
        {
            Thread.sleep(250);
            b = (byte) sin.read();
        }        
        System.out.printf("LIDO: %02x\n", b);
        return b;
    }    
}
